package wmo

import (
	"context"
	"go.mongodb.org/mongo-driver/bson"
)

func (c *Coll[TData]) InsertOne(ctx context.Context, valueIn TData) (TData, error) {
	insRes, err := c.coll.InsertOne(ctx, valueIn)
	if err != nil {
		return *new(TData), err
	}

	mongoRes := c.coll.FindOne(ctx, bson.M{"_id": insRes.InsertedID})

	return c.decodeSingle(ctx, mongoRes)
}
